%============================================================================
% script to plot Rician density function and cumulative disribution
%
% Input parameter
%   K: constant (5)
%
%============================================================================
%---------------------- assignment of input parameter -----------------------

K=5;

%--------------------- calculate rho for given K ----------------------------

rho=exp(K/2)*sqrt(2/pi)/((1+K)*besseli(0,K/2)+K*besseli(1,K/2));

%-------------------------- set range to plot -------------------------------

rStart=0;rStop=2.5;r=rStart:(rStop-rStart)/300:rStop;

%-------------------------- compute Rayleigh pdf ----------------------------

rho1=sqrt(2/pi);
pdfRayleigh=r/(rho1^2).*exp(-((r/rho1).^2)/2);

%------------------------- compute Rayleigh CDF -----------------------------

CDFRayleigh=1-exp(-(((r/rho1).^2)/2));
MedianRayleigh=rho1*sqrt(log(4));

%--------------------------- compute Rice pdf -------------------------------

pdfRice=r/(rho^2).*exp(-(((r/rho).^2)/2+K)).*besseli(0,r/rho*sqrt(2*K));

%--------------- compute Rice CDF using trapzoidal integration --------------

CDFRice=cumtrapz(r,pdfRice);

%------------------------------- ready to plot ------------------------------

figure(1); clf
%------------------------------- the first plot -----------------------------

subplot(2,1,1);
plot(r,pdfRayleigh);
ylabel('pdf');
xlabel('r');
axis([0 2.5 0 .8])
title('Rician Density Function for K=5')
y=get(gca,'ytick');

Mean=rho1*sqrt(pi/2);
line([Mean Mean],[min(y) max(y)],'linestyle',':','color','r');
str=sprintf('Mean=%3.1f ',Mean);
text(Mean,0.35,str,'HorizontalAlignment','right');

%----------------------------- the second plot ------------------------------

subplot(2,1,2);
plot(r,CDFRayleigh);
hold on;plot(r,CDFRice,'-.');hold off;
ylabel('CDF');
xlabel('r');
title('Cumulative Distribution Functions')

text(.7,0.1,'K=5');

Median=MedianRayleigh;
str=sprintf('Median=%3.3f ',Median);
text(Median,0.75,str,'HorizontalAlignment','right');
y=get(gca,'ytick');
line([Median Median],[min(y) max(y)],'linestyle',':','color','r');
line([0 Median],[0.5 0.5],'linestyle',':','color','r');

%-------------------------------- legend ------------------------------------

line([1.2 1.65],[0.22 0.22]);
text(1.7,0.22,'Rayleigh CDF','VerticalAlignment','middle');
line([1.2 1.65],[0.3 0.3],'linestyle','-.');
text(1.7,0.3,'Rician CDF','VerticalAlignment','middle');

%------------------------------- end of program -----------------------------
